#ifndef NET_Regress_CONJ_H
#define NET_Regress_CONJ_H

#include "net_regress.h"
#include "conj.h"

class NET_Regress_Conj : public NET_Regress, Conj
{
public:
  NET_Regress_Conj(int n_batch, 
		   int num_ip, 
		   int num_op,
		   int dbg,
		   int _itmax,
		   int _msteps,
		   int _rich,
		   float _tol,
		   float _lambda,
		   float _prior_var);
  NET_Regress_Conj(const NET_Regress_Conj &);
  ~NET_Regress_Conj();
  double train_params(int n_points, float** in, float** out, float** targ) ;
  double train_params(int n_points, float** in, float** out, float** targ, 
	       float* weights) ;
  double evaluate_gradient(double* dw); 
private:
  int itmax;
  int rich;
  float tol;
  float* ones_vec;
};

#endif

