#ifndef NODE_TERM_H
#define NODE_TERM_H

#include "node.h"
#include "network.h"

class Node_Term : public Node
{
public:
  Node_Term(int n_batch, 
	    int num_ip, 
	    int num_op, 
	    int debug,
	    int node_id,
	    Network* _expert);
  Node_Term(int n_batch, FILE* fp);
  Node_Term(Node& old, Network* default_expert);
  Node_Term(const Node_Term & old);
  Node_Term(Node& old);
  virtual ~Node_Term();
  void randomize_weights(real offset);
  void randomize_weights(real xprt_offset, real gate_offset);
  void update_params(int n_points, real** in,  real** targ);
  void update_hypers(int n_points, real** in,  real** targ);
  void train(int n_points, real** in, real** targ);
  void update_params(int n_points, real** in,  real** targ,
					 int node_id);
  void update_hypers(int n_points, real** in,  real** targ,
					 int node_id);
  void train(int n_points, real** in, real** targ, 
			 int node_id);
  void init(int n_points, real** in,  real** targ);  
  int is_terminal() { return 0;};
  void print_posteriors(int point);
  void read_weights(FILE* fp);
  void write_weights(FILE* fp);
  Network* get_expert(){ return expert;};
  void set_expert(Network* xprt) { expert = xprt;}  
  void set_joint_prob(real prob, real* in, int point);
  real get_joint_prob(int point) { return joint_prob[point];};
  real set_dens(int point, real* in, real* targ);
  real get_dens();
  void reset_nodes();
  void set_posts(int point);
private:
  Network* expert;
};

#endif

